/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// This file avoids compiling the headers too many times
// which would slow compiling way down.

#define byte unsigned char

#include "error.cpp"
#include "variable.cpp"
#include "bus.cpp"
#include "displaybox.cpp"
#include "linuxmain.cpp"
#include "component.cpp"
#include "symbol.cpp" 
#include "widget.cpp"
#include "componenttype.cpp"
#include "pin.cpp"
#include "symboltable.cpp"
#include "project.cpp"
#include "attribute.cpp"
#include "break.cpp"
#include "Scenix.cpp"
#include "HexFile.cpp"
#include "basecomponents.cpp"
#include "Oscillo.cpp"
#include "lstfile.cpp"
