/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __DISPLAYBOX_H__
#define __DISPLAYBOX_H__

#define BOX_H 1
#define BOX_V 2

class displaybox;

class displayboxconstructor : public symbolconstructor
{
  friend boxwidget;
  friend displaybox;
  int type;
  list<symbolconstructor> *constructors;

protected:
  symbol *_create(symbol *parent);
  
public:
  void revconstructors();
  displayboxconstructor(attribute *paddingattribute) 
    : symbolconstructor(paddingattribute) { constructors = (list<symbolconstructor> *) NULL; }
  void addconstructor(symbolconstructor *sc);
  void settype(int type) { displayboxconstructor::type = type; }
};

class displaybox : public symbol
{
  int boxtype;
  friend boxwidget;
  list<symbolconstructor> *constructors;

  virtual symbol *_getlocalsymbol(symbolname *);
public:
  static displaybox *getempty(int type);
  symbolwidget *getwidget();
  displaybox(int name, attribute *attribs, symbol *parent, int boxtype,  list<symbolconstructor> *constructors = (list<symbolconstructor> *) NULL);
  //  displaybox(int name, attribute *attribs, symbol *parent, int boxtype,  list<symbol> *children);
};



#endif
