/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __NUMBER_H__
#define __NUMBER_H__

#undef MIN
#define MIN(x, y) (((x) < (y)) ? (x) : (y))
#undef MAX
#define MAX(x, y) (((x) > (y)) ? (x) : (y))

#ifdef __BORLANDC__
#define INFINITY (1./0.) //added by FM
#else
#ifndef INFINITY
#ifndef HUGE_VAL
#define INFINITY (1./0.)
#else
#define INFINITY HUGE_VAL
#endif
#endif
#endif

#ifndef NAN
#define NAN (INFINITY / INFINITY)
#endif

typedef double real;

inline int log2(unsigned int x)
{
  int i=0;
  if (!x) return -1;
  while (!(x&1)) {
    i++;
    x=x>>1;
  }
  return i;
}

#ifndef __linux
inline int isnan(real r)
{
  return (r == 0) && (r == 1);
}
#endif

#endif
