/*
  DUST: Simulator for circuits containing a SX microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __REAL_H__
#define __REAL_H__

class realsymbol : public symbol
{
public:
  bool readonly;
  virtual real getvalue() = 0;
  virtual void _setvalue(real val) {};
  void setvalue(real val) { if (!readonly) _setvalue(val); };
  realsymbol(int name, attribute *attribs, symbol *parent) : symbol(name, attribs, parent) {}
};

class realptr : public realsymbol
{
  real *ptr;
public:
  realwidget *getwidget() { return new realwidget(getattributes(), this); }
  virtual real getvalue() { return *ptr; };
  virtual void _setvalue(real val) { *ptr = val; };
  realptr(int name, attribute *attribs, symbol *parent, real *ptr) : realsymbol(name, attribs, parent) { realptr::ptr = ptr; }
};

/*class realfunc : public realsymbol
{
  real (*ptr)();
public:
  realwidget *getwidget() { return new realwidget(getattributes(), this); }
  virtual real getvalue() { return ptr(); };
  virtual void setvalue(real val) { };
  realfunc(int name, attribute *attribs, symbol *parent, real (*ptr)()) : realsymbol(name, attribs, parent) { realfunc::ptr = ptr; }
  };*/

#endif
